#!/usr/local/bin/perl -w

use strict ;

use Test::More ;
use Carp ;

my $ok ;

use Sort::Maker qw( sorter_source ) ;


BEGIN{ 

	$ok = use_ok( 'Sort::Maker' ) ;
print "OK [$ok] $@\n" ;

}
#print "FOO\n" ;

my @sort_tests = (

	{
		skip	=> 0,
		name	=> 'simple string',
		data	=> [ qw( z e a k ) ],
		sort	=> sub { $a cmp $b },
		opts	=> [ qw( string ) ],
	},
	{
		skip	=> 0,
		name	=> 'simple number',
		data	=> [ 32, 2, 9, 7 ],
		sort	=> sub { $a <=> $b },
		opts	=> [ qw( number ) ],
	},
	{
		skip	=> 0,
		name	=> 'simple string ref_in',
		data	=> [ qw( z e a k ) ],
		sort	=> sub { $a cmp $b },
		opts	=> [ qw( ref_in string ) ],
		ref_in	=> 1,
	},
	{
		skip	=> 0,
		name	=> 'simple string ref_out',
		data	=> [ qw( z e a k ) ],
		sort	=> sub { $a cmp $b },
		opts	=> [ qw( ref_out string ) ],
		ref_out	=> 1,
	},
) ;

plan tests => @sort_tests * 2 ;

foreach my $test ( @sort_tests ) {

	next if $test->{skip} ;

	my( $name, $data, $sort, $opts ) = @{$test}{qw( name data sort opts )} ;

	my @sorted = sort { $sort->() } @{$data} ;

#print "gold SORTED [@sorted]\n" ;

	foreach my $style ( qw( plain ST ) ) {

		my $sorter = make_sorter( $style, @{$opts} ) ;

print "SORT [$sorter] [$@]\n" ;

print sorter_source( $sorter ) || '' ;

die unless $sorter ;

		my @in = $test->{ref_in} ? $data : @{$data} ;

		my @test_sorted = $sorter->( @in ) ;

		@test_sorted = @{$test_sorted[0]} if $test->{ref_out} ;

#print "style SORTED [@test_sorted]\n" ;

		ok( eq_array( \@sorted, \@test_sorted ),
			"$style sort of $name" ) ;
	}
}
